commit 193f1c7f0cc42b3a525c3a776912124d8588f78f
Author: Dominic Cleal <dcleal@redhat.com>
Date:   Tue May 27 09:55:33 2014 +0100

    Import rubygem-hammer_cli, hammer_cli_foreman, rest-client

diff --git a/rubygem-hammer_cli/cli_config.yml b/rubygem-hammer_cli/cli_config.yml
new file mode 100644
index 000000000..e11161e38
--- /dev/null
+++ b/rubygem-hammer_cli/cli_config.yml
@@ -0,0 +1,15 @@
+:ui:
+  :interactive: true
+  :per_page: 20
+  :history_file: '~/.hammer/history'
+
+
+# enable/disable color output of logger in Clamp commands
+:watch_plain: false
+
+:log_dir: '~/.hammer/log'
+:log_level: 'error'
+:log_api_calls: false
+#:log_owner: 'foreman'
+#:log_group: 'foreman'
+#:log_size: 5 #MB
diff --git a/rubygem-hammer_cli/hammer_cli-0.1.1.gem b/rubygem-hammer_cli/hammer_cli-0.1.1.gem
new file mode 120000
index 000000000..0fd6c4464
--- /dev/null
+++ b/rubygem-hammer_cli/hammer_cli-0.1.1.gem
@@ -0,0 +1 @@
+../.git/annex/objects/4Q/qk/SHA256E-s93696--8ed6878847894b69bd0c09317fc4e2e0557662bf2bf38d53f851d8ad85a6c7e2.1.gem/SHA256E-s93696--8ed6878847894b69bd0c09317fc4e2e0557662bf2bf38d53f851d8ad85a6c7e2.1.gem
\ No newline at end of file
diff --git a/rubygem-hammer_cli/rubygem-hammer_cli.spec b/rubygem-hammer_cli/rubygem-hammer_cli.spec
new file mode 100644
index 000000000..94fd38964
--- /dev/null
+++ b/rubygem-hammer_cli/rubygem-hammer_cli.spec
@@ -0,0 +1,215 @@
+%global gemname hammer_cli
+%global confdir hammer
+
+%if 0%{?rhel}
+%global gem_dir /usr/lib/ruby/gems/1.8
+%endif
+
+%global geminstdir %{gem_dir}/gems/%{gemname}-%{version}
+
+Summary: Universal command-line interface for Foreman
+Name: rubygem-%{gemname}
+Version: 0.1.1
+Release: 1%{?dist}
+Group: Development/Languages
+License: GPLv3
+URL: http://github.com/theforeman/hammer-cli
+Source0: %{gemname}-%{version}.gem
+Source1: cli_config.yml
+
+%if 0%{?rhel} == 6 || 0%{?fedora} < 19
+Requires: ruby(abi)
+%endif
+
+# on ruby 1.8.x
+Requires: ruby(rubygems)
+Requires: rubygem(clamp)
+Requires: rubygem(rest-client)
+Requires: rubygem(logging)
+Requires: rubygem(awesome_print)
+Requires: rubygem(table_print) >= 1.5.0
+Requires: rubygem(highline)
+Requires: rubygem(fast_gettext)
+Requires: rubygem(locale) <= 2.0.9
+Requires: rubygem(json)
+Requires: rubygem(fastercsv)
+Requires: rubygem(mime-types) < 2.0.0
+Requires: rubygem(apipie-bindings) >= 0.0.8
+%if 0%{?fedora}
+BuildRequires: rubygems-devel
+%endif
+%if 0%{?rhel} == 6 || 0%{?fedora} < 19
+BuildRequires: ruby(abi)
+%endif
+BuildRequires: ruby(rubygems)
+BuildRequires: ruby
+BuildArch: noarch
+Provides: rubygem(%{gemname}) = %{version}
+
+%description
+Hammer cli provides universal extendable CLI interface for ruby apps
+
+
+%package doc
+Summary: Documentation for %{name}
+Group: Documentation
+Requires: %{name} = %{version}-%{release}
+BuildArch: noarch
+
+%description doc
+Documentation for %{name}
+
+
+%prep
+%setup -q -c -T
+mkdir -p .%{_bindir}
+mkdir -p .%{gem_dir}
+gem install --local --install-dir .%{gem_dir} \
+            --bindir .%{_bindir} \
+            --force %{SOURCE0}
+
+%build
+
+%install
+mkdir -p %{buildroot}%{gem_dir}
+cp -pa .%{gem_dir}/* \
+        %{buildroot}%{gem_dir}/
+
+mkdir -p %{buildroot}%{_bindir}
+cp -pa .%{_bindir}/* \
+        %{buildroot}%{_bindir}/
+
+find %{buildroot}%{geminstdir}/bin -type f | xargs chmod a+x
+
+mkdir -p %{buildroot}%{_sysconfdir}/bash_completion.d
+mv %{buildroot}%{geminstdir}/hammer_cli_complete %{buildroot}%{_sysconfdir}/bash_completion.d/%{gemname}
+
+mkdir -p %{buildroot}%{_sysconfdir}/%{confdir}/cli.modules.d
+install -m 755 %{SOURCE1} %{buildroot}%{_sysconfdir}/%{confdir}/cli_config.yml
+rm -r %{buildroot}%{geminstdir}/config
+
+
+%files
+%dir %{geminstdir}
+%{_bindir}/hammer
+%{_sysconfdir}/bash_completion.d/%{gemname}
+%{_sysconfdir}/%{confdir}/cli.modules.d
+%{_sysconfdir}/%{confdir}/cli_config.yml
+%{geminstdir}/bin
+%{geminstdir}/lib
+%{geminstdir}/locale
+%{geminstdir}/LICENSE
+%exclude %{gem_dir}/cache/%{gemname}-%{version}.gem
+%{gem_dir}/specifications/%{gemname}-%{version}.gemspec
+
+%files doc
+%doc %{geminstdir}/test
+%doc %{gem_dir}/doc/%{gemname}-%{version}
+%doc %{geminstdir}/doc
+%doc %{geminstdir}/README.md
+
+%changelog
+* Tue May 20 2014 Martin Bačovský <martin.bacovsky@gmail.com> 0.1.1-1
+- Rebased hammer_cli to 0.1.1 (martin.bacovsky@gmail.com)
+
+* Wed Mar 26 2014 Martin Bačovský <martin.bacovsky@gmail.com> 0.1.0-1
+- Bump to 0.1.0 (martin.bacovsky@gmail.com)
+- hammer_cli - new config location and dependencies (tstrachota@redhat.com)
+
+* Wed Jan 29 2014 Martin Bačovský <mbacovsk@redhat.com> 0.0.18-1
+- Bump to 0.0.18 (mbacovsk@redhat.com)
+
+* Thu Jan 23 2014 Martin Bačovský <mbacovsk@redhat.com> 0.0.16-1
+- Bump to 0.0.16 (mbacovsk@redhat.com)
+
+* Tue Jan 21 2014 Martin Bačovský <mbacovsk@redhat.com> 0.0.15-1
+- Bump to 0.0.15 (mbacovsk@redhat.com)
+
+* Tue Jan 07 2014 Dominic Cleal <dcleal@redhat.com> 0.0.14-2
+- Require fastercsv and mime-types on Fedora to avoid gemspec conflict
+  (dcleal@redhat.com)
+
+* Thu Dec 19 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.14-1
+- Bump to 0.0.14 (mbacovsk@redhat.com)
+
+* Wed Dec 18 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.13-1
+- Bump to 0.0.13 (mbacovsk@redhat.com)
+
+* Thu Dec 05 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.12-1
+- Bump to 0.0.12 (mbacovsk@redhat.com)
+
+* Tue Nov 26 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.11-1
+- Bump to 0.0.11 (mbacovsk@redhat.com)
+
+* Fri Nov 08 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.9-1
+- Bumped to 0.0.9 (mbacovsk@redhat.com)
+
+* Tue Oct 29 2013 Tomas Strachota <tstrachota@redhat.com> 0.0.8-1
+- Update to Hammer CLI Foreman 0.0.8
+
+* Wed Oct 09 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.7-1
+- Bumped to 0.0.7 (mbacovsk@redhat.com)
+- fixed error handling while loading hammer modules
+
+* Tue Oct 08 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.6-2
+- Added depenedency on fastercsv on ruby 1.8 (mbacovsk@redhat.com)
+
+* Tue Oct 08 2013 Tomas Strachota <tstrachota@redhat.com> 0.0.6-1
+- fixes #3184 - update hammer dependencies
+
+* Thu Sep 26 2013 Sam Kottler <shk@redhat.com> 0.0.5-1
+- Cherry pick hammer_cli version bump (shk@redhat.com)
+
+* Tue Aug 27 2013 Dominic Cleal <dcleal@redhat.com> 0.0.3-4
+- Install bash completion extension (dcleal@redhat.com)
+
+* Mon Aug 26 2013 Sam Kottler <shk@redhat.com> 0.0.3-3
+- Fix typo in macro (shk@redhat.com)
+- Use macros provided by rubygems-devel on Fedora (shk@redhat.com)
+
+* Mon Aug 26 2013 Sam Kottler <shk@redhat.com> 0.0.3-2
+- Add configuration example to packaged files (shk@redhat.com)
+- Fix readme path (shk@redhat.com)
+- Add docs and other files that are new in the 0.0.3 release (shk@redhat.com)
+- Add docs and other files that are new in the 0.0.3 release (shk@redhat.com)
+- Bump hammer_cli version to 0.0.3 (shk@redhat.com)
+
+* Thu Aug 15 2013 Sam Kottler <shk@redhat.com> 0.0.2-15
+- Remove SCL conditional (shk@redhat.com)
+
+* Thu Aug 15 2013 Sam Kottler <shk@redhat.com> 0.0.2-14
+- Add multi_json dependency to hammer and fix gem_dir (shk@redhat.com)
+- Fix changelog (shk@redhat.com)
+
+* Tue Aug 13 2013 Sam Kottler <shk@redhat.com> 0.0.2-13
+- Add logging requirement (shk@redhat.com)
+
+* Tue Aug 13 2013 Sam Kottler <shk@redhat.com> 0.0.2-10
+- Rebuilding on RHEL
+
+* Mon Aug 12 2013 Sam Kottler <shk@redhat.com> 0.0.2-9
+- Bump version
+
+* Mon Aug 12 2013 Sam Kottler <shk@redhat.com> 0.0.2-8
+- Bump hammer version (shk@redhat.com)
+
+* Tue Aug 06 2013 Sam Kottler <shk@redhat.com> 0.0.1-7
+- Add a missing %% (shk@redhat.com)
+- Remove ruby(abi) for f19 (shk@redhat.com)
+
+* Tue Aug 06 2013 Sam Kottler <shk@redhat.com> 0.0.1-6
+- Fix bindir (shk@redhat.com)
+
+* Tue Aug 06 2013 Sam Kottler <shk@redhat.com> 0.0.1-5
+- Don't require ruby-abi on F19+ (shk@redhat.com)
+
+* Thu Aug 01 2013 Sam Kottler <shk@redhat.com> 0.0.1-4
+- Rebuild
+
+* Thu Aug 01 2013 Sam Kottler <shk@redhat.com> 0.0.1-3
+- Removed abi version for hammer_cli deps (shk@redhat.com)
+
+* Thu Aug 01 2013 Sam Kottler <shk@redhat.com> 0.0.1-2
+- Initial package with tito
+* Wed Jul 31 2013  <shk@redhat.com> - 0.0.1-1
+- Initial package
diff --git a/rubygem-hammer_cli_foreman/foreman.yml b/rubygem-hammer_cli_foreman/foreman.yml
new file mode 100644
index 000000000..07a2ed0f2
--- /dev/null
+++ b/rubygem-hammer_cli_foreman/foreman.yml
@@ -0,0 +1,9 @@
+:foreman:
+    :enable_module: true
+    :host: 'https://localhost/'
+
+    # Check cache status on each request
+    # :refresh_cache: false
+
+    # API request timeout, set -1 for infinity
+    # :request_timeout: 120 #seconds
diff --git a/rubygem-hammer_cli_foreman/hammer_cli_foreman-0.1.1.gem b/rubygem-hammer_cli_foreman/hammer_cli_foreman-0.1.1.gem
new file mode 120000
index 000000000..863c3f6bf
--- /dev/null
+++ b/rubygem-hammer_cli_foreman/hammer_cli_foreman-0.1.1.gem
@@ -0,0 +1 @@
+../.git/annex/objects/QF/v6/SHA256E-s114688--e97c7ec12eb60c088a47bb8a3b37bb91f9daba087a66c6bf778eadd12a9f97d5.1.gem/SHA256E-s114688--e97c7ec12eb60c088a47bb8a3b37bb91f9daba087a66c6bf778eadd12a9f97d5.1.gem
\ No newline at end of file
diff --git a/rubygem-hammer_cli_foreman/rubygem-hammer_cli_foreman.spec b/rubygem-hammer_cli_foreman/rubygem-hammer_cli_foreman.spec
new file mode 100644
index 000000000..4b569f1c1
--- /dev/null
+++ b/rubygem-hammer_cli_foreman/rubygem-hammer_cli_foreman.spec
@@ -0,0 +1,153 @@
+%global gemname hammer_cli_foreman
+%global confdir hammer
+
+%if 0%{?rhel}
+%global gem_dir /usr/lib/ruby/gems/1.8
+%endif
+
+%global geminstdir %{gem_dir}/gems/%{gemname}-%{version}
+
+Summary: Universal command-line interface for Foreman
+Name: rubygem-%{gemname}
+Version: 0.1.1
+Release: 1%{?dist}
+Group: Development/Languages
+License: GPLv3
+URL: http://github.com/theforeman/hammer-cli-foreman
+Source0: %{gemname}-%{version}.gem
+Source1: foreman.yml
+
+%if 0%{?rhel} == 6 || 0%{?fedora} < 19
+Requires: ruby(abi)
+%endif
+
+Requires: ruby(rubygems)
+Requires: rubygem(hammer_cli) >= 0.1.1
+BuildRequires: ruby(rubygems)
+%if 0%{?fedora}
+BuildRequires: rubygems-devel
+%endif
+BuildRequires: ruby
+BuildArch: noarch
+Provides: rubygem(%{gemname}) = %{version}
+
+%description
+Hammer cli provides universal extendable CLI interface for ruby apps
+
+
+%package doc
+Summary: Documentation for %{name}
+Group: Documentation
+Requires: %{name} = %{version}-%{release}
+BuildArch: noarch
+
+%description doc
+Documentation for %{name}
+
+
+%prep
+%setup -q -c -T
+mkdir -p .%{gem_dir}
+gem install --local --install-dir .%{gem_dir} \
+            --force %{SOURCE0}
+
+%install
+mkdir -p %{buildroot}%{_sysconfdir}/%{confdir}/cli.modules.d
+install -m 755 %{SOURCE1} %{buildroot}%{_sysconfdir}/%{confdir}/cli.modules.d/foreman.yml
+mkdir -p %{buildroot}%{gem_dir}
+cp -pa .%{gem_dir}/* \
+        %{buildroot}%{gem_dir}/
+
+%files
+%dir %{geminstdir}
+%{geminstdir}/lib
+%{geminstdir}/locale
+%config(noreplace) %{_sysconfdir}/%{confdir}/cli.modules.d/foreman.yml
+%exclude %{gem_dir}/cache/%{gemname}-%{version}.gem
+%{gem_dir}/specifications/%{gemname}-%{version}.gemspec
+
+%files doc
+%doc %{gem_dir}/doc/%{gemname}-%{version}
+%doc %{geminstdir}/README.md
+%doc %{geminstdir}/doc
+%doc %{geminstdir}/test
+
+
+%changelog
+* Tue May 20 2014 Martin Bačovský <martin.bacovsky@gmail.com> 0.1.1-1
+- Rebased hammer_cli_foreman to 0.1.1 (martin.bacovsky@gmail.com)
+- Removed credentials from config file (martin.bacovsky@gmail.com)
+
+* Wed Mar 26 2014 Martin Bačovský <martin.bacovsky@gmail.com> 0.1.0-1
+- Bump to 0.1.0 (martin.bacovsky@gmail.com)
+- hammer_cli_foreman - new config location (tstrachota@redhat.com)
+
+* Wed Jan 29 2014 Martin Bačovský <mbacovsk@redhat.com> 0.0.18-1
+- Bump to 0.0.18 (mbacovsk@redhat.com)
+
+* Thu Jan 23 2014 Martin Bačovský <mbacovsk@redhat.com> 0.0.17-1
+- Bump to 0.0.17 (mbacovsk@redhat.com)
+
+* Tue Jan 21 2014 Martin Bačovský <mbacovsk@redhat.com> 0.0.16-1
+- Bump to 0.0.16 (mbacovsk@redhat.com)
+
+* Thu Dec 19 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.15-1
+- Bump to 0.0.15 (mbacovsk@redhat.com)
+
+* Wed Dec 18 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.13-1
+- Bump to 0.0.13 (mbacovsk@redhat.com)
+
+* Thu Dec 05 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.12-1
+- Bump to 0.0.12 (mbacovsk@redhat.com)
+
+* Tue Nov 26 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.11-1
+- Bump to 0.0.11 (mbacovsk@redhat.com)
+
+* Fri Nov 08 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.10-1
+- bump to 0.0.10 (mbacovsk@redhat.com)
+- updated dependencies
+
+* Mon Nov 04 2013 Dominic Cleal <dcleal@redhat.com> 0.0.9-2
+- Mark cli_config.yml as a config file (dcleal@redhat.com)
+- Update default config for Foreman installation and non-root users
+  (dcleal@redhat.com)
+
+* Tue Oct 29 2013 Tomas Strachota <tstrachota@redhat.com> 0.0.9-1
+- Update to Hammer CLI Foreman 0.0.9
+
+* Wed Oct 23 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.8-1
+- Rebase to 0.0.8 (mbacovsk@redhat.com)
+
+* Thu Oct 10 2013 Martin Bačovský <mbacovsk@redhat.com> 0.0.7-1
+- Bumped to 0.0.7 (mbacovsk@redhat.com)
+- Fixed default config file
+- remove deps on awesome_print and terminal-table
+
+* Tue Oct 08 2013 Tomas Strachota <tstrachota@redhat.com> 0.0.6-1
+- Update to the latest version of Hammer CLI Foreman
+
+* Thu Sep 26 2013 Sam Kottler <shk@redhat.com> 0.0.5-1
+- Bump the version in the spec (shk@redhat.com)
+- Update to the latest version (shk@redhat.com)
+
+* Mon Aug 26 2013 Sam Kottler <shk@redhat.com> 0.0.3-2
+- Use rubygems-devel on fedora instead of custom macros (shk@redhat.com)
+
+* Mon Aug 26 2013 Sam Kottler <shk@redhat.com> 0.0.3-1
+- Remove the 0.0.1 gem bin (shk@redhat.com)
+- Bump to version 0.0.3 (shk@redhat.com)
+
+* Thu Aug 15 2013 Sam Kottler <shk@redhat.com> 0.0.1-5
+- Add configuration to install (shk@redhat.com)
+
+* Thu Aug 15 2013 Sam Kottler <shk@redhat.com> 0.0.1-4
+- Version bump for rebuild
+
+* Thu Aug 15 2013 Sam Kottler <shk@redhat.com> 0.0.1-3
+- Bump version
+
+* Thu Aug 15 2013 Sam Kottler <shk@redhat.com>
+- Initial import of the gem (shk@redhat.com)
+
+* Thu Aug 15 2013 Sam Kottler <shk@redhat.com> - 0.0.1-1
+- Initial package
diff --git a/rubygem-rest-client/rest-client-1.6.1.gem b/rubygem-rest-client/rest-client-1.6.1.gem
new file mode 120000
index 000000000..208d4664b
--- /dev/null
+++ b/rubygem-rest-client/rest-client-1.6.1.gem
@@ -0,0 +1 @@
+../.git/annex/objects/45/GM/SHA256E-s55296--7db53b5ef2ab200fabe841642c73ffeec9eaf2bb4f1ba9ef597b3b6ddd4ff4e7.1.gem/SHA256E-s55296--7db53b5ef2ab200fabe841642c73ffeec9eaf2bb4f1ba9ef597b3b6ddd4ff4e7.1.gem
\ No newline at end of file
diff --git a/rubygem-rest-client/rest-client.spec b/rubygem-rest-client/rest-client.spec
new file mode 100644
index 000000000..66fe6940a
--- /dev/null
+++ b/rubygem-rest-client/rest-client.spec
@@ -0,0 +1,75 @@
+%{?scl:%scl_package rubygem-%{gem_name}}
+%{!?scl:%global pkg_name %{name}}
+
+%define gem_name rest-client
+
+Summary: Simple REST client for Ruby, inspired by microframework syntax for specifying actions
+Name: %{?scl_prefix}rubygem-%{gem_name}
+Version: 1.6.1
+Release: 5%{?dist}
+Group: Development/Languages
+License: GPLv2+ or Ruby
+URL: http://github.com/archiloque/rest-client
+Source0: http://rubygems.org/gems/%{gem_name}-%{version}.gem
+BuildRoot: %{_tmppath}/%{pkg_name}-%{version}-%{release}-root-%(%{__id_u} -n)
+Requires: %{?scl_prefix}rubygems
+Requires: %{?scl_prefix}ruby(abi) = 1.9.1
+Requires: %{?scl_prefix}rubygem(mime-types) >= 1.16
+BuildRequires: %{?scl_prefix}rubygems-devel
+BuildArch: noarch
+Provides: %{?scl_prefix}rubygem(%{gem_name}) = %{version}
+
+%description
+A simple Simple HTTP and REST client for Ruby, inspired by the Sinatra
+microframework style of specifying actions: get, put, post, delete.
+
+%prep
+
+%build
+
+%install
+rm -rf %{buildroot}
+mkdir -p %{buildroot}%{gem_dir}
+
+%{?scl:scl enable %{scl} "}
+gem install --local --install-dir %{buildroot}%{gem_dir} \
+            --force --rdoc %{SOURCE0}
+%{?scl:"}
+
+mkdir -p %{buildroot}/%{_bindir}
+mv %{buildroot}%{gem_dir}/bin/* %{buildroot}/%{_bindir}
+rmdir %{buildroot}%{gem_dir}/bin
+find %{buildroot}%{gem_instdir}/bin -type f | xargs chmod a+x
+
+%clean
+rm -rf %{buildroot}
+
+%files
+%defattr(-, root, root, -)
+
+%{_bindir}/restclient
+
+%{gem_dir}/gems/%{gem_name}-%{version}/
+
+%doc %{gem_dir}/doc/%{gem_name}-%{version}
+
+%doc %{gem_instdir}/README.rdoc
+
+%doc %{gem_instdir}/history.md
+
+%{gem_dir}/cache/%{gem_name}-%{version}.gem
+%{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
+
+%changelog
+* Wed Feb 27 2013 Miroslav Suchý <msuchy@redhat.com> 1.6.1-4
+- BR rubygems-devel (msuchy@redhat.com)
+
+* Wed Feb 27 2013 Miroslav Suchý <msuchy@redhat.com> 1.6.1-3
+- new package built with tito
+
+* Wed Nov 10 2010 Shannon Hughes <shughes@redhat.com> 1.6.1-2
+- - mass gem update - updated specs for fedora guidelines - removed dev
+  dependencies in specs (shughes@redhat.com)
+
+* Fri Nov 05 2010 Shannon Hughes <shughes@redhat.com> - 1.6.1-1
+- Initial package