commit 5d238b96034d25cfb45b7f2c6c225b4a65c436ed
Author: Daniel Lobato <elobatocs@gmail.com>
Date:   Fri Apr 18 17:52:38 2014 +0200

    Release 1.5.0-RC1, updated changelogs
    
    Updated changelogs properly

diff --git a/debian/precise/foreman-installer/changelog b/debian/precise/foreman-installer/changelog
index f07746696..4703600d6 100644
--- a/debian/precise/foreman-installer/changelog
+++ b/debian/precise/foreman-installer/changelog
@@ -1,3 +1,21 @@
+foreman-installer (1.5.0~rc1-1) stable; urgency=low
+
+  * 1.5.0 RC1 released
+
+ -- Daniel Lobato Garcia <elobatocs@gmail.com>  Fri, 18 Apr 2014 17:45:00 +0100
+
+foreman-installer (1.4.2-1) stable; urgency=low
+
+  * 1.4.2 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Mon, 24 Mar 2014 11:02:00 +0100
+
+foreman-installer (1.4.1-1) stable; urgency=low
+
+  * 1.4.1 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Thu, 20 Feb 2014 11:05:00 +0100
+
 foreman-installer (1.4.0-2) stable; urgency=low
 
   * Use librarian-puppet in rules file
diff --git a/debian/precise/foreman-proxy/changelog b/debian/precise/foreman-proxy/changelog
index 2e5a66457..05912d18a 100644
--- a/debian/precise/foreman-proxy/changelog
+++ b/debian/precise/foreman-proxy/changelog
@@ -1,3 +1,21 @@
+foreman-proxy (1.5.0~rc1-1) stable; urgency=low
+
+  * 1.5.0 RC1 released
+
+ -- Daniel Lobato Garcia <elobatocs@gmail.com>  Fri, 18 Apr 2014 17:45:00 +0100
+
+foreman-proxy (1.4.2-1) stable; urgency=low
+
+  * 1.4.2 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Mon, 24 Mar 2014 11:02:00 +0100
+
+foreman-proxy (1.4.1-1) stable; urgency=low
+
+  * 1.4.1 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Thu, 20 Feb 2014 11:05:00 +0100
+
 foreman-proxy (1.4.0-1) stable; urgency=low
 
   * 1.4.0 released
diff --git a/debian/precise/foreman/changelog b/debian/precise/foreman/changelog
index d42bf2cb5..d2070d963 100644
--- a/debian/precise/foreman/changelog
+++ b/debian/precise/foreman/changelog
@@ -1,3 +1,21 @@
+foreman (1.5.0~rc1-1) stable; urgency=low
+
+  * 1.5.0 RC1 released
+
+ -- Daniel Lobato Garcia <elobatocs@gmail.com>  Fri, 18 Apr 2014 17:45:00 +0100
+
+foreman (1.4.2-1) stable; urgency=low
+
+  * 1.4.2 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Mon, 24 Mar 2014 11:02:00 +0100
+
+foreman (1.4.1-1) stable; urgency=low
+
+  * 1.4.1 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Thu, 20 Feb 2014 11:05:00 +0100
+
 foreman (1.4.0-1) stable; urgency=low
 
   * 1.4.0 released
diff --git a/debian/squeeze/foreman-installer/changelog b/debian/squeeze/foreman-installer/changelog
index f07746696..4703600d6 100644
--- a/debian/squeeze/foreman-installer/changelog
+++ b/debian/squeeze/foreman-installer/changelog
@@ -1,3 +1,21 @@
+foreman-installer (1.5.0~rc1-1) stable; urgency=low
+
+  * 1.5.0 RC1 released
+
+ -- Daniel Lobato Garcia <elobatocs@gmail.com>  Fri, 18 Apr 2014 17:45:00 +0100
+
+foreman-installer (1.4.2-1) stable; urgency=low
+
+  * 1.4.2 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Mon, 24 Mar 2014 11:02:00 +0100
+
+foreman-installer (1.4.1-1) stable; urgency=low
+
+  * 1.4.1 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Thu, 20 Feb 2014 11:05:00 +0100
+
 foreman-installer (1.4.0-2) stable; urgency=low
 
   * Use librarian-puppet in rules file
diff --git a/debian/squeeze/foreman-proxy/changelog b/debian/squeeze/foreman-proxy/changelog
index f1ba3b594..77f783ab5 100644
--- a/debian/squeeze/foreman-proxy/changelog
+++ b/debian/squeeze/foreman-proxy/changelog
@@ -1,3 +1,21 @@
+foreman-proxy (1.5.0~rc1-1) stable; urgency=low
+
+  * 1.5.0 RC1 released
+
+ -- Daniel Lobato Garcia <elobatocs@gmail.com>  Fri, 18 Apr 2014 17:45:00 +0100
+
+foreman-proxy (1.4.2-1) stable; urgency=low
+
+  * 1.4.2 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Mon, 24 Mar 2014 11:02:00 +0100
+
+foreman-proxy (1.4.1-1) stable; urgency=low
+
+  * 1.4.1 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Thu, 20 Feb 2014 11:05:00 +0100
+
 foreman-proxy (1.4.0-1) stable; urgency=low
 
   * 1.4.0 released
diff --git a/debian/squeeze/foreman/changelog b/debian/squeeze/foreman/changelog
index d1c8e294f..c81474ed3 100644
--- a/debian/squeeze/foreman/changelog
+++ b/debian/squeeze/foreman/changelog
@@ -1,3 +1,21 @@
+foreman (1.5.0~rc1-1) stable; urgency=low
+
+  * 1.5.0 RC1 released
+
+ -- Daniel Lobato Garcia <elobatocs@gmail.com>  Fri, 18 Apr 2014 17:45:00 +0100
+
+foreman (1.4.2-1) stable; urgency=low
+
+  * 1.4.2 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Mon, 24 Mar 2014 11:02:00 +0100
+
+foreman (1.4.1-1) stable; urgency=low
+
+  * 1.4.1 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Thu, 20 Feb 2014 11:05:00 +0100
+
 foreman (1.4.0-1) stable; urgency=low
 
   * 1.4.0 released
diff --git a/debian/wheezy/foreman-installer/changelog b/debian/wheezy/foreman-installer/changelog
index eb1a4a9b4..007699270 100644
--- a/debian/wheezy/foreman-installer/changelog
+++ b/debian/wheezy/foreman-installer/changelog
@@ -1,3 +1,21 @@
+foreman-installer (1.5.0~rc1-1) stable; urgency=low
+
+  * 1.5.0 RC1 released
+
+ -- Daniel Lobato Garcia <elobatocs@gmail.com>  Fri, 18 Apr 2014 17:45:00 +0100
+
+foreman-installer (1.4.2-1) stable; urgency=low
+
+  * 1.4.2 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Mon, 24 Mar 2014 11:02:00 +0100
+
+foreman-installer (1.4.1-1) stable; urgency=low
+
+  * 1.4.1 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Thu, 20 Feb 2014 11:05:00 +0100
+
 foreman-installer (1.4.0-2) stable; urgency=low
 
   * Use librarian-puppet in rules file
diff --git a/debian/wheezy/foreman-proxy/changelog b/debian/wheezy/foreman-proxy/changelog
index 4334add20..af0f71a2e 100644
--- a/debian/wheezy/foreman-proxy/changelog
+++ b/debian/wheezy/foreman-proxy/changelog
@@ -1,3 +1,21 @@
+foreman-proxy (1.5.0~rc1-1) stable; urgency=low
+
+  * 1.5.0 RC1 released
+
+ -- Daniel Lobato Garcia <elobatocs@gmail.com>  Fri, 18 Apr 2014 17:45:00 +0100
+
+foreman-proxy (1.4.2-1) stable; urgency=low
+
+  * 1.4.2 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Mon, 24 Mar 2014 11:02:00 +0100
+
+foreman-proxy (1.4.1-1) stable; urgency=low
+
+  * 1.4.1 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Thu, 20 Feb 2014 11:05:00 +0100
+
 foreman-proxy (1.4.0-1) stable; urgency=low
 
   * 1.4.0 released
diff --git a/debian/wheezy/foreman/changelog b/debian/wheezy/foreman/changelog
index 04c5e7b20..f51b97b81 100644
--- a/debian/wheezy/foreman/changelog
+++ b/debian/wheezy/foreman/changelog
@@ -1,3 +1,21 @@
+foreman (1.5.0~rc1-1) stable; urgency=low
+
+  * 1.5.0 RC1 released
+
+ -- Daniel Lobato Garcia <elobatocs@gmail.com>  Fri, 18 Apr 2014 17:45:00 +0100
+
+foreman (1.4.2-1) stable; urgency=low
+
+  * 1.4.2 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Mon, 24 Mar 2014 11:02:00 +0100
+
+foreman (1.4.1-1) stable; urgency=low
+
+  * 1.4.1 released
+
+ -- Greg Sutcliffe <greg.sutcliffe@gmail.com>  Thu, 20 Feb 2014 11:05:00 +0100
+
 foreman (1.4.0-1) stable; urgency=low
 
   * 1.4.0 released